package vocleditor.actions;

import java.util.List;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.ui.IWorkbenchPart;

import vocleditor.command.NotExpCommand;
import vocleditor.edit.parts.VOCLExpEditPart;
import vocleditor.figures.VOCLExpFigure;
import VOCLModel.VOCLExpression;

/**
 * @author Stefan
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class NotVOCLExpFigureAction extends SelectionAction {

	public static final String ID = "NotAction";

	public NotVOCLExpFigureAction(IWorkbenchPart part) {
		super(part);
		setId(ID);
		setText("Negate VOCLExpression");
	}
	/**
	 * @see org.eclipse.gef.ui.actions.WorkbenchPartAction#calculateEnabled()
	 */
	protected boolean calculateEnabled() {
		return canPerformAction();
	}

	private boolean canPerformAction() {
		if (getSelectedObjects().isEmpty())
			return false;
		List parts = getSelectedObjects();
		for (int i = 0; i < parts.size(); i++) {
			Object o = parts.get(i);
			if (!(o instanceof EditPart))
				return false;
			EditPart part = (EditPart) o;
			if ((part.getModel() instanceof VOCLExpression))
				return true;
			else
				return false;
		}
		return true;

	}
	/**
		 * Returns the ClassifierRole oder ClassifierRoleSetCommand. It depends
		 * on which EditpPart was selected.
		 * @return the command
		 */
	private Command getCommand() {
		Object selection =
			((StructuredSelection) getSelection()).getFirstElement();
		if (selection instanceof VOCLExpEditPart) {
			NotExpCommand create = new NotExpCommand();
			create.setParent(((VOCLExpEditPart)selection).getModel());
			create.setFigure((VOCLExpFigure)((VOCLExpEditPart)selection).getFigure());
			return create;
		}
		return null;
	}

	/**
	 * @see org.eclipse.jface.action.IAction#run()
	 */
	public void run() {
		execute(getCommand());
	}

}
