package vocleditor.command;

import org.eclipse.gef.commands.Command;

import vocleditor.model.Helpers;
import VOCLModel.NavExp;
/**
 * 
 * Class       : CreateNavexpCommand<br/>
 * Package     : vocleditor.command<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 22.05.2004<br/>
 * Description : Command for Creating a new if-then-else-Expression.<br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 */
public class CreateNavexpCommand extends Command {

	//the current navexp
	NavExp navexp;
	//the parent of the navexp
	Object parent;
	//the position of the navexp in the parentfigure
	int position;

	public void setNavexp(NavExp navexp) {
		this.navexp = navexp;
	}

	public void setParent(Object parent) {
		this.parent = parent;
	}
	
	public void setPosition(int position){
		this.position = position;
	}

	/**
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	public void execute() {
		navexp.setIndex(position);
		Helpers.addToParent(navexp,parent,position);
	}
	
	/**
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo() {
		Helpers.removeFromParent(parent,position);
	}
	
	/**
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	public void redo() {
		Helpers.addToParent(navexp,parent,position);
	}
}
