package vocleditor.command;

import VOCLModel.BendPoint;

/**
 * 
 * Class       : DeleteBendpointCommand<br/>
 * Package     : vocleditor.command<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 01.07.2004<br/>
 * Description : Command for deleting Bendpoints.<br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 */
public class DeleteBendpointCommand extends BendpointCommand {

	//the deleted BendPoint
	private BendPoint point;
	private int index;

	/**
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	public void execute() {
		index = getIndex();
		point = (BendPoint) getAssociationRole().getBendPoint().get(index);
		getAssociationRole().getBendPoint().remove(point);
	}

	/**
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo() {
		getAssociationRole().getBendPoint().add(index, point);
	}
	
	/**
	 * @see vocleditor.command.BendpointCommand#redo()
	 */
	public void redo() {
		getAssociationRole().getBendPoint().remove(point);
	}


}
