package vocleditor.command;


import VOCLModel.Constraint;
import VOCLModel.VOCLDiagram;
import VOCLModel.VariableDeclaration;



/**
 * 
 * Class       : DeleteConstraintCommand<br/>
 * Package     : vocleditor.command<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 14.06.2004<br/>
 * Description : Command for deleting Constraints.<br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 */
public class DeleteConstraintCommand
	extends org.eclipse.gef.commands.Command {
	private static final String DeleteCommand_Label = "DeleteConstraintCommand";
	//the current constraint
	private Constraint constraint;
	//the context variables
	private VariableDeclaration varDec;
	//the parent
	private VOCLDiagram diagram;

	/**
	 * Constructor.
	 */
	public DeleteConstraintCommand() {
		super(DeleteCommand_Label);
	}


	/**
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	public void execute() {
		diagram = constraint.getVOCLDiagram();
		diagram.getConstraint().remove(constraint);
	}

	/**
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	public void redo() {
		execute();
	}

	/**
	 * Sets the current Constraint.
	 * @param constraint the current Constraint.
	 */
	public void setConstraint(Constraint constraint) {
		this.constraint = constraint;
	}

	/**
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo() {
		diagram.getConstraint().add(constraint); 						
	}
	
	

}
