package vocleditor.command;

import org.eclipse.gef.commands.Command;
import org.eclipse.swt.widgets.Shell;

import vocleditor.figures.VOCLExpFigure;
import VOCLModel.VOCLExpression;

/**
 * 
 * Class       : NotExpCommand<br/>
 * Package     : vocleditor.command<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 10.07.2004<br/>
 * Description : Command for drawing a cross above a VOCLExpFigure.<br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 */
public class NotExpCommand extends Command {

	int position;
	Object parent;
	Shell shell;
	VOCLExpFigure figure;
	/**
	 * Constructor
	 * @param shell
	 */
	public NotExpCommand() {
	}
	
	/**
	 * the Position in the parent Figure
	 * @param p
	 */
	public void setPosition(int p ){
		position = p;
	}

	/**
	 * Set the parent of this NotExpression.
	 * @param parent
	 */
	public void setParent(Object parent) {
		this.parent = parent;
	}


	/**
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	public void execute() {
		if (parent instanceof VOCLExpression){
			((VOCLExpression)parent).setIsNegated(!((VOCLExpression)parent).isIsNegated());
		}
		figure.validate();
	}

	/**
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo() {
	    ((VOCLExpression)parent).setIsNegated(!((VOCLExpression)parent).isIsNegated());	
	}
	
	/**
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	public void redo() {
		((VOCLExpression)parent).setIsNegated(!((VOCLExpression)parent).isIsNegated());
	}


	/**
	 * @param figure
	 */
	public void setFigure(VOCLExpFigure figure) {
		this.figure = figure;
	}

}
