package vocleditor.dialogs;

import java.util.Iterator;
import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;

import vocleditor.model.Helpers;
import vocleditor.model.NavExpConstants;
import VOCLModel.Attribute;
import VOCLModel.ClassifierRoleSet;
import VOCLModel.Constraint;
import VOCLModel.NavExp;
import VOCLModel.VariableDeclaration;


/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* *************************************
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED
* for this machine, so Jigloo or this code cannot be used legally
* for any corporate or commercial purpose.
* *************************************
*/
/**
 * 
 * Class       : CreateNewClassifierRoleSetDialog<br/>
 * Package     : vocleditor.dialog<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 26.06.2004<br/>
 * Description : This class provides a dialog for creating and editing a ClassifierRoleSet.<br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 */
public class CreateNewClassifierRoleSetDialog
	extends org.eclipse.swt.widgets.Dialog
	implements AttributeDialogInterface {
	private Label callVarLabel;
	private Text sumVarNameText;
	private Vector attributes = new Vector();
	private Button editButton;
	private Button removeButton;
	private Button addButton;
	private Label label2;
	private TableColumn valueVarColumn;
	private TableColumn attrTypeComponent;
	private TableColumn attrNameColumn;
	private Table varList;
	private Label sumVarLabel;
	private Text callVarNameText;
	private Button cancelButton;
	String classRoleName = "";
	String classRoleType = "";
	private Shell dialogShell;
	private boolean isCanceled = false;
	private Label label1;
	private Label label3;
	private Label label4;
	private String methodName = "";
	private NavExp navexp;
	private Button okayButton;
	private Vector parameters;
	private String callVarName = "";
	private String resultType = "";
	private String sumVarName = "";

	private Text roleNameText;
	private Text roleTypeText;
	private Combo setOpCombo;

	private Constraint constraint;
	private ClassifierRoleSet classifierRole;

	public CreateNewClassifierRoleSetDialog(Shell parent) {
		super(parent, SWT.NULL);
	}

	/** Auto-generated event handler method */
	protected void cancelButtonMouseDown(MouseEvent evt) {
		isCanceled = true;
		dialogShell.close();
	}

	/**
	 * Returns a String of the method.
	* @return method string
	*/
	public String getMethodName() {
		return methodName;
	}

	/**
	 * @see vocleditor.dialogs.AttributeDialogInterface#getNavExp()
	 */
	public NavExp getNavExp() {
		return navexp;
	}

	/**
	 * @see vocleditor.dialogs.AttributeDialogInterface#getAttributes()
	 */
	public Vector getAttributes() {
		return attributes;
	}

	/**
	 * Returns the CallVariable.
	 * @return call Variable
	 */
	public String getCallVarName() {
		return callVarName;
	}

	/**
	 * Returns the IteratorVariable. 
	 * @return the IteratorVariable
	 */
	public String getSumVarName() {
		return sumVarName;
	}

	/**
	 * Returns the OperationKind.
	 * @return the OperationKind
	 */
	public String getResultType() {
		return resultType;
	}

	/**
	* Auto-generated method
	*/
	public String getRoleName() {
		return classRoleName;
	}

	/**
	 * Returns the RoleType for this ClassifierRoleSet.
	 * @return the RoleType
	 */
	public String getRoleType() {
		return classRoleType;
	}

	/**
	 * Indicates whether this dialog was aborted.
	 * @return isCancelled
	 */
	public boolean isCanceled() {
		return isCanceled;
	}

	/** Auto-generated event handler method */
	protected void okayButtonMouseDown(MouseEvent evt) {

		//		constraint = Helpers.searchConstraint(navexp);
		classRoleType = roleTypeText.getText();
		classRoleName = roleNameText.getText();
		callVarName = callVarNameText.getText();
		sumVarName = sumVarNameText.getText();
		resultType = setOpCombo.getItem(setOpCombo.getSelectionIndex());

		//Check if iteratorVariable appears in Attribute
		if (resultType.equals(NavExpConstants.SUM)) {
			if(attributes.size() == 0){
				MessageBox box =
					new MessageBox(dialogShell, SWT.OK | SWT.ICON_WARNING);
				box.setText("Warning");
				box.setMessage(
					"The Iterator variable is not bound at an attribute");
				box.open();
				return;
			}else{
				for (int i = 0; i < attributes.size(); i += 4) {
					String attrVar = (String) attributes.elementAt(i + 3);
					if (!attrVar.equals(sumVarName)) {
						MessageBox box =
							new MessageBox(dialogShell, SWT.OK | SWT.ICON_WARNING);
						box.setText("Warning");
						box.setMessage(
							"The Iterator variable is not bound at an attribute");
						box.open();
						return;
					}
				}	
			}
		}

		if (resultType.equals(NavExpConstants.SIZE)) {
			for (int i = 0; i < attributes.size(); i += 4) {
				String attrVar = (String) attributes.elementAt(i + 3);
				if (attrVar.equals(callVarName)) {
					MessageBox box =
						new MessageBox(dialogShell, SWT.OK | SWT.ICON_WARNING);
					box.setText("Warning: variable already used");
					box.setMessage(
						"The size-varialbe is already used by an attribute");
					box.open();
					return;
				}
			}
		}

		//Check if variable declaration already exists ...
		if (navexp != null) {
			if (resultType.equals(NavExpConstants.SIZE)) {
				if (Helpers
					.checkVariableAlreadyExists(navexp, callVarName, false)) {
					showVariableDeclarationAlreadyExistsDialog(callVarName);
					return;
				}
			}
			//			check if Variable of an attribute is already defined in the NavExp
			for (int i = 0; i < attributes.size(); i += 4) {
				String name = (String) attributes.elementAt(i + 3);
				if (Helpers.checkVariableAlreadyExists(navexp, name, true)) {
					showVariableDeclarationAlreadyExistsDialog(name);
					return;
				}
			}

			if (Helpers
				.checkVariableAlreadyExists(navexp, classRoleName, false)) {
				showVariableDeclarationAlreadyExistsDialog(classRoleName);
				return;
			}
		}
		if (classRoleType == ""
			|| (resultType.equals(NavExpConstants.SIZE) && callVarName == "")) {
			MessageBox msg =
				new MessageBox(dialogShell, SWT.ICON_INFORMATION | SWT.OK);

			msg.setMessage(
				"Please enter a valid role type !");
			msg.open();
			return;
		}

		dialogShell.close();
	}
	/**
	* Opens the Dialog Shell.
	* Auto-generated code - any changes you make will disappear.
	*/
	public void open() {
		try {
			preInitGUI();

			Shell parent = getParent();
			dialogShell =
				new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
			dialogShell.setText(getText());
			roleNameText = new Text(dialogShell, SWT.NULL);
			label1 = new Label(dialogShell, SWT.NULL);
			okayButton = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
			cancelButton = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
			callVarNameText = new Text(dialogShell, SWT.NULL);
			label3 = new Label(dialogShell, SWT.NULL);
			setOpCombo = new Combo(dialogShell, SWT.NULL);
			sumVarLabel = new Label(dialogShell, SWT.NULL);
			label4 = new Label(dialogShell, SWT.NULL);
			roleTypeText = new Text(dialogShell, SWT.NULL);
			varList = new Table(dialogShell, SWT.NULL);
			attrNameColumn = new TableColumn(varList, SWT.NULL);
			attrTypeComponent = new TableColumn(varList, SWT.NULL);
			valueVarColumn = new TableColumn(varList, SWT.NULL);
			label2 = new Label(dialogShell, SWT.NULL);
			addButton = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
			removeButton = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
			editButton = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
			sumVarNameText = new Text(dialogShell, SWT.NULL);
			callVarLabel = new Label(dialogShell, SWT.NULL);

			dialogShell.setText("create SetClassifierRole");
			dialogShell.setSize(332, 421);

			roleNameText.setSize(new org.eclipse.swt.graphics.Point(174, 20));
			roleNameText.setBounds(
				new org.eclipse.swt.graphics.Rectangle(99, 14, 180, 20));

			label1.setText("role name:");
			label1.setSize(new org.eclipse.swt.graphics.Point(70, 20));
			label1.setBounds(
				new org.eclipse.swt.graphics.Rectangle(30, 15, 70, 20));
			label1.setAlignment(SWT.RIGHT);

			okayButton.setText("OK");
			okayButton.setSize(new org.eclipse.swt.graphics.Point(80, 30));
			okayButton.setBounds(
				new org.eclipse.swt.graphics.Rectangle(19, 381, 80, 30));
			okayButton.addMouseListener(new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					okayButtonMouseDown(evt);
				}
			});

			cancelButton.setText("Cancel");
			cancelButton.setSize(new org.eclipse.swt.graphics.Point(80, 30));
			cancelButton.setBounds(
				new org.eclipse.swt.graphics.Rectangle(114, 381, 80, 30));
			cancelButton.addMouseListener(new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					cancelButtonMouseDown(evt);
				}
			});

			callVarNameText.setSize(
				new org.eclipse.swt.graphics.Point(174, 20));
			callVarNameText.setBounds(
				new org.eclipse.swt.graphics.Rectangle(101, 117, 180, 20));

			label3.setText("role type:");
			label3.setAlignment(SWT.RIGHT);
			label3.setSize(new org.eclipse.swt.graphics.Point(70, 20));
			label3.setBounds(
				new org.eclipse.swt.graphics.Rectangle(24, 50, 70, 20));

			setOpCombo.setSize(new org.eclipse.swt.graphics.Point(68, 21));
			setOpCombo.setBounds(
				new org.eclipse.swt.graphics.Rectangle(100, 87, 93, 21));
			setOpCombo.addSelectionListener(new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					setOpComboWidgetSelected(evt);
				}
			});

			sumVarLabel.setText("iterator variable:");
			sumVarLabel.setAlignment(SWT.RIGHT);
			sumVarLabel.setSize(new org.eclipse.swt.graphics.Point(83, 17));
			sumVarLabel.setBounds(
				new org.eclipse.swt.graphics.Rectangle(10, 149, 83, 17));

			label4.setText("operation type:");
			label4.setAlignment(SWT.RIGHT);
			label4.setSize(new org.eclipse.swt.graphics.Point(83, 20));
			label4.setBounds(
				new org.eclipse.swt.graphics.Rectangle(12, 89, 83, 20));

			roleTypeText.setSize(new org.eclipse.swt.graphics.Point(174, 20));
			roleTypeText.setBounds(
				new org.eclipse.swt.graphics.Rectangle(100, 49, 180, 20));

			varList.setHeaderVisible(true);
			varList.setLinesVisible(true);
			varList.setSize(new org.eclipse.swt.graphics.Point(196, 161));
			varList.setBounds(
				new org.eclipse.swt.graphics.Rectangle(21, 195, 213, 178));
			varList.addSelectionListener(new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					varListWidgetSelected(evt);
				}
			});

			attrNameColumn.setText("Name");
			attrNameColumn.setWidth(60);

			attrTypeComponent.setText("Typ");
			attrTypeComponent.setWidth(73);

			valueVarColumn.setText("Value/Variable");
			valueVarColumn.setWidth(80);

			label2.setText("Attribute:");
			label2.setSize(new org.eclipse.swt.graphics.Point(63, 15));
			label2.setBounds(
				new org.eclipse.swt.graphics.Rectangle(24, 173, 63, 15));

			addButton.setText("&Add");
			addButton.setSize(new org.eclipse.swt.graphics.Point(60, 30));
			addButton.setBounds(
				new org.eclipse.swt.graphics.Rectangle(248, 198, 60, 30));
			addButton.addMouseListener(new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					addButtonMouseDown(evt);
				}
			});

			removeButton.setText("&Entfernen");
			removeButton.setSize(new org.eclipse.swt.graphics.Point(60, 30));
			removeButton.setEnabled(false);
			removeButton.setBounds(
				new org.eclipse.swt.graphics.Rectangle(249, 239, 60, 30));
			removeButton.addMouseListener(new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					removeButtonMouseDown(evt);
				}
			});

			editButton.setText("&Bearbeiten");
			editButton.setSize(new org.eclipse.swt.graphics.Point(60, 30));
			editButton.setEnabled(false);
			editButton.setBounds(
				new org.eclipse.swt.graphics.Rectangle(248, 280, 60, 30));
			editButton.addMouseListener(new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					editButtonMouseDown(evt);
				}
			});

			sumVarNameText.setSize(new org.eclipse.swt.graphics.Point(174, 20));
			sumVarNameText.setBounds(
				new org.eclipse.swt.graphics.Rectangle(102, 147, 180, 20));

			callVarLabel.setText("variable name:");
			callVarLabel.setAlignment(SWT.RIGHT);
			callVarLabel.setSize(new org.eclipse.swt.graphics.Point(83, 17));
			callVarLabel.setBounds(
				new org.eclipse.swt.graphics.Rectangle(10, 121, 83, 17));
			dialogShell.setLayout(null);
			Rectangle bounds = dialogShell.computeTrim(0, 0, 332, 421);
			dialogShell.setSize(bounds.width, bounds.height);
			postInitGUI();
			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/** Add your post-init code in here 	*/
	public void postInitGUI() {
		for (int x = 0; x < NavExpConstants.CLASSIFIER_SET_TYPES.length; x++) {
			setOpCombo.add(NavExpConstants.CLASSIFIER_SET_TYPES[x]);
		}
		setOpCombo.select(0);
		sumVarLabel.setVisible(false);
		sumVarNameText.setVisible(false);
		callVarLabel.setVisible(false);
		callVarNameText.setVisible(false);

		//if the ClassifierRoleSet is edited
		//fill the dialog with data
		if (classifierRole != null) {
			cancelButton.setEnabled(false);
			if (classifierRole.getClassifierVar() == null) {
				roleNameText.setText("");
				roleTypeText.setText(classifierRole.getType());
			} else {
				roleNameText.setText(
					classifierRole.getClassifierVar().getVarName());
				roleTypeText.setText(
					classifierRole.getClassifierVar().getType());
			}

			if (classifierRole.getAttribute().size() > 0) {
				for (Iterator it = classifierRole.getAttribute().iterator();
					it.hasNext();
					) {
					Attribute attr = (Attribute) it.next();
					TableItem item = new TableItem(varList, SWT.NULL);
					item.setText(0, attr.getName());
					attributes.add(attr.getName());
					item.setText(1, attr.getType());
					attributes.add(attr.getType());
					attributes.add(attr.getValue());

					if (!attr.getValue().equals("")) {
						item.setText(2, attr.getValue());
						attributes.add("");
					} else {
						item.setText(
							2,
							attr.getVariableDeclaration().getVarName());
						attributes.add(
							attr.getVariableDeclaration().getVarName());
					}
				}

			}

			if (classifierRole.getOperationKind().equals("SIZE")
				|| classifierRole.getOperationKind().equals("SUM")) {
				VariableDeclaration callVar =
					classifierRole.getOpKindEnum().getCallVar();
				setOpCombo.select(2);
				callVarName = callVar.getVarName();
				callVarLabel.setVisible(true);
				callVarNameText.setVisible(true);
				callVarNameText.setText(callVar.getVarName());
				if (classifierRole.getOperationKind().equals("SUM")) {
					VariableDeclaration iterationVar =
						classifierRole.getOpKindEnum().getIteratorVar();
					sumVarName = iterationVar.getVarName();
					setOpCombo.select(3);
					sumVarLabel.setVisible(true);
					sumVarNameText.setVisible(true);
					sumVarNameText.setText(sumVarName);
				}
			}

		}

	}
	/** Add your pre-init code in here 	*/
	public void preInitGUI() {
		isCanceled = false;
	}

	/** Auto-generated event handler method */
	protected void setOpComboWidgetSelected(SelectionEvent evt) {
		callVarNameText.setVisible(setOpCombo.getSelectionIndex() >= 2);
		callVarLabel.setVisible(setOpCombo.getSelectionIndex() >= 2);
		sumVarNameText.setVisible(setOpCombo.getSelectionIndex() == 3);
		sumVarLabel.setVisible(setOpCombo.getSelectionIndex() == 3);
	}

	/**
	 * @param vector
	 */
	public void setParameters(Vector vector) {
		parameters = vector;
	}
	private void showVariableDeclarationAlreadyExistsDialog(String resultName) {

		MessageBox msg =
			new MessageBox(dialogShell, SWT.ICON_INFORMATION | SWT.OK);

		msg.setMessage(
			"Eine Variable mit dem Namen \""
				+ resultName
				+ "\" existiert bereits.");
		msg.open();
		return;

	}

	/** Auto-generated event handler method */
	protected void varListWidgetSelected(SelectionEvent evt) {
		editButton.setEnabled(true);
		removeButton.setEnabled(true);
	}

	/** Auto-generated event handler method */
	protected void addButtonMouseDown(MouseEvent evt) {
		NewAttributeDialog d =
			new NewAttributeDialog(dialogShell, SWT.NULL, this, false);
		d.open();
		String name = d.getName();
		String value = d.getValue();
		String type = d.getType();
		String varName = d.getVarName();
		if (!d.isCancelled()) { //Okay was pressed ...
			addItem(name, type, value, varName);
		}
		removeButton.setEnabled(varList.getItemCount() != 0);
		editButton.setEnabled(varList.getItemCount() != 0);

	}

	/**
	 * Add the attributevalues to the table.
	 * @param name attributename
	 * @param type attributetype
	 * @param value attributevalue or
	 * @param varName attributevariable
	 */
	public void addItem(
		String name,
		String type,
		String value,
		String varName) {
		TableItem tableItem = new TableItem(varList, SWT.NULL);
		tableItem.setText(0, name);
		tableItem.setText(1, type);
		tableItem.setText(2, value + varName);

		attributes.add(name);
		attributes.add(type);
		attributes.add(value);
		attributes.add(varName);
	}
	/** Auto-generated event handler method */
	protected void removeButtonMouseDown(MouseEvent evt) {
		int index = varList.getSelectionIndex();
		if (index < 0) {
			MessageBox msg = new MessageBox(dialogShell, SWT.ICON_INFORMATION);
			msg.setMessage("Selectieren Sie bitte ein Attribut");
			msg.setText("Keine Selektion");
			msg.open();
			return;
		}
		attributes.remove(index * 3);
		attributes.remove(index * 3);
		attributes.remove(index * 3);
		attributes.remove(index * 3);
		varList.remove(index);
		removeButton.setEnabled(varList.getItemCount() != 0);
		editButton.setEnabled(varList.getItemCount() != 0);
	}

	/** Auto-generated event handler method */
	protected void editButtonMouseDown(MouseEvent evt) {
		int index = varList.getSelectionIndex();
		if (index < 0) {
			MessageBox msg = new MessageBox(dialogShell, SWT.ICON_INFORMATION);
			msg.setMessage("Selectieren Sie bitte ein Attribut");
			msg.setText("Keine Selektion");
			msg.open();
			return;
		}
		NewAttributeDialog d =
			new NewAttributeDialog(dialogShell, SWT.NULL, this, true);
		d.setName((String) attributes.get(index * 4));
		d.setType((String) attributes.get(index * 4 + 1));
		d.setValue((String) attributes.get(index * 4 + 2));
		d.setVarName((String) attributes.get(index * 4 + 3));
		d.open();

		String name = d.getName();
		String value = d.getValue();
		String type = d.getType();
		String varName = d.getVarName();

		if (!name.equals("")) { //Okay was pressed ...
			editButton.setEnabled(true);
			TableItem tableItem = varList.getItem(index);
			tableItem.setText(0, name);
			tableItem.setText(1, type);
			tableItem.setText(2, value + varName);
			attributes.set(index * 4, name);
			attributes.set(index * 4 + 1, type);
			attributes.set(index * 4 + 2, value);
			attributes.set(index * 4 + 3, varName);
		}
	}
	/**
	 * @param exp
	 */
	public void setNavexp(NavExp exp) {
		navexp = exp;
	}

	/**
	 * Set the current ClassifierRoleSet. It is used for editing.
	 * @param set the current ClassifierRoleSet
	 */
	public void setClassifierRole(ClassifierRoleSet set) {
		classifierRole = set;
	}

}
