package vocleditor.dialogs;

import java.util.Iterator;
import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import vocleditor.model.NavExpConstants;
import VOCLModel.ClassifierNode;
import VOCLModel.VariableDeclaration;


/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* *************************************
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED
* for this machine, so Jigloo or this code cannot be used legally
* for any corporate or commercial purpose.
* *************************************
*/
/**
 * 
 * Class       : NewAttributeDialog<br/>
 * Package     : vocleditor.dialog<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 26.06.2004<br/>
 * Description : This class provides a dialog for creating and editing variables of ClassifierNodes<br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 */
public class NewAttributeDialog extends org.eclipse.swt.widgets.Dialog {
	private Combo booleanCombo;
	private Combo typeCombo;
	private Text valueText;
	private Button varButton;
	private Text variableText;
	private Button attributeValueButton;
	private Text nameText;
	private Button cancel;
	private Button Ok;
	private Label Typ;
	private Label Name;
	private Shell dialogShell;
	private boolean isCancelled;
	String attrName = "";
	String attrType = "";
	String attrValue = "";
	String attrVarName = "";
	int typeIndex;
	private AttributeDialogInterface parentDialog;
	private boolean editModus = false;

	public NewAttributeDialog(
		Shell parent,
		int style,
		AttributeDialogInterface parentDialog,
		boolean editModus) {
		super(parent, style);
		this.editModus = editModus;
		this.parentDialog = parentDialog;
	}

	/**
	* Opens the Dialog Shell.
	* Auto-generated code - any changes you make will disappear.
	*/
	public void open() {
		try {
			preInitGUI();

			Shell parent = getParent();
			dialogShell =
				new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
			dialogShell.setText(getText());
			nameText = new Text(dialogShell, SWT.NULL);
			Name = new Label(dialogShell, SWT.NULL);
			Typ = new Label(dialogShell, SWT.NULL);
			Ok = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
			cancel = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
			attributeValueButton =
				new Button(dialogShell, SWT.RADIO | SWT.LEFT);
			variableText = new Text(dialogShell, SWT.NULL);
			varButton = new Button(dialogShell, SWT.RADIO | SWT.LEFT);
			typeCombo = new Combo(dialogShell, SWT.NULL);
			valueText = new Text(dialogShell, SWT.NULL);
			booleanCombo = new Combo(dialogShell, SWT.NULL);

			dialogShell.setText("Definition of an attribute");
			dialogShell.setSize(304, 189);

			nameText.setSize(new org.eclipse.swt.graphics.Point(114, 20));
			nameText.setBounds(
				new org.eclipse.swt.graphics.Rectangle(156, 20, 120, 20));

			Name.setText("attribute name:");
			Name.setAlignment(SWT.RIGHT);
			Name.setSize(new org.eclipse.swt.graphics.Point(100, 20));
			Name.setBounds(
				new org.eclipse.swt.graphics.Rectangle(51, 20, 100, 20));

			Typ.setText("attribute type:");
			Typ.setAlignment(SWT.RIGHT);
			Typ.setSize(new org.eclipse.swt.graphics.Point(90, 20));
			Typ.setBounds(
				new org.eclipse.swt.graphics.Rectangle(59, 53, 90, 20));

			Ok.setText("Ok");
			Ok.setSize(new org.eclipse.swt.graphics.Point(60, 30));
			Ok.setBounds(
				new org.eclipse.swt.graphics.Rectangle(136, 149, 60, 30));
			Ok.addMouseListener(new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					OkMouseDown(evt);
				}
			});

			cancel.setText("Cancel");
			cancel.setSize(new org.eclipse.swt.graphics.Point(60, 30));
			cancel.setBounds(
				new org.eclipse.swt.graphics.Rectangle(216, 150, 60, 30));
			cancel.addMouseListener(new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					cancelMouseDown(evt);
				}
			});

			attributeValueButton.setText("value");
			attributeValueButton.setSelection(true);
			attributeValueButton.setSize(
				new org.eclipse.swt.graphics.Point(63, 23));
			attributeValueButton.setBounds(
				new org.eclipse.swt.graphics.Rectangle(78, 78, 63, 23));
			attributeValueButton.addSelectionListener(new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					attributeValueButtonWidgetSelected(evt);
				}
			});

			variableText.setSize(new org.eclipse.swt.graphics.Point(114, 20));
			variableText.setEnabled(true);
			variableText.setBounds(
				new org.eclipse.swt.graphics.Rectangle(156, 110, 120, 20));

			varButton.setText("variable");
			varButton.setSize(new org.eclipse.swt.graphics.Point(63, 23));
			varButton.setBounds(
				new org.eclipse.swt.graphics.Rectangle(78, 106, 63, 23));
			varButton.addSelectionListener(new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					varButtonWidgetSelected(evt);
				}
			});

			typeCombo.setSize(new org.eclipse.swt.graphics.Point(95, 21));
			typeCombo.setBounds(
				new org.eclipse.swt.graphics.Rectangle(155, 50, 120, 21));
			typeCombo.addSelectionListener(new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					typeComboWidgetSelected(evt);
				}
			});

			valueText.setSize(new org.eclipse.swt.graphics.Point(114, 20));
			valueText.setBounds(
				new org.eclipse.swt.graphics.Rectangle(154, 79, 120, 20));

			booleanCombo.setSize(new org.eclipse.swt.graphics.Point(95, 21));
			booleanCombo.setEnabled(true);
			booleanCombo.setBounds(
				new org.eclipse.swt.graphics.Rectangle(155, 79, 120, 21));
			dialogShell.setLayout(null);
			Rectangle bounds = dialogShell.computeTrim(0, 0, 304, 189);
			dialogShell.setSize(bounds.width, bounds.height);
			postInitGUI();
			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/** Add your pre-init code in here 	*/
	public void preInitGUI() {

	}

	/** Add your post-init code in here 	*/
	public void postInitGUI() {
		typeIndex = 0;
		booleanCombo.add("TRUE");
		booleanCombo.add("FALSE");

		nameText.setText(attrName);

		for (int x = 0; x < NavExpConstants.TYPES.length; x++) {
			typeCombo.add(NavExpConstants.TYPES[x]);
		}

		if (parentDialog.getNavExp() != null) {

			Iterator i =
				parentDialog.getNavExp().getClassifierNode().iterator();

			while (i.hasNext()) {
				ClassifierNode classnode = (ClassifierNode) i.next();
				typeCombo.add(classnode.getType());
			}
		}
		
		for (int x = 0; x < typeCombo.getItemCount(); x++) {
			String compare = typeCombo.getItem(x);
			if (compare.equals(attrType)) {
				typeIndex = x;
			}
		}

		typeCombo.select(typeIndex);
		valueText.setText(attrValue);
		variableText.setText(attrVarName);
		booleanCombo.select((attrValue.equals("FALSE")) ? 1 : 0);
		variableText.setVisible(false);
		boolean showVarRadioButton = (attrVarName != "");
		if(showVarRadioButton){
			varButton.setSelection(showVarRadioButton);
			booleanCombo.setVisible(false);
			variableText.setVisible(true);
			valueText.setVisible(false);	
		}
		
		attributeValueButton.setSelection(!showVarRadioButton);
	}

	private boolean varDecExistButHasDifferentType(
		String attrName,
		String attrValue) {
		//Check all vardeclaration within this context ...
		if (parentDialog.getNavExp() != null) {

			Iterator i =
				parentDialog.getNavExp().getVariableDeclaration().iterator();
			while (i.hasNext()) {
				VariableDeclaration vardeclare = (VariableDeclaration) i.next();
				if (vardeclare.getVarName().equals(attrName)) {
					if (vardeclare.getType().equals(attrValue)) {
						return true;
					}
				}
			}
			//Check current classrole vardeclarations ...
			Vector attr = parentDialog.getAttributes();
			for (int x = 0; x < attr.size(); x += 4) {
				if (((String) attr.get(x + 3)).equals(attrName)) {
					if (((String) attr.get(x + 1)).equals(attrValue)) {
						return true;
					}
				}
			}
		}
		return false;
	}
	private boolean attrNameAlreadyExists(String name) {
		//		Check current classrole vardeclarations ...	parentDialog.getAttributes().remove(index);

		if (!editModus) {

			Vector attr = parentDialog.getAttributes();
			for (int x = 0; x < attr.size(); x += 4) {
				String temp = (String) attr.get(x);
				if ((temp).equals(attrName)) {
					return true;
				}
			}
		}
		return false;
	}
	/** Auto-generated event handler method */
	protected void OkMouseDown(MouseEvent evt) {
		isCancelled = false;
		//name of the attribute
		attrName = nameText.getText();
		//type of the attribute
		attrType = typeCombo.getText();
		
		// checks whether the name already exists in this classifierNode
		if (attrNameAlreadyExists(attrName)) {
			MessageBox msg =
				new MessageBox(dialogShell, SWT.ICON_INFORMATION | SWT.OK);
			msg.setMessage(
				"Attributname existiert bereits, bitte ndern Sie den Attributnamen.");
			msg.open();
			return;
		}
		
		if (varButton.getSelection()) {
			attrVarName = variableText.getText();
			if (varDecExistButHasDifferentType(attrVarName, attrType)) {
				MessageBox msg =
					new MessageBox(dialogShell, SWT.ICON_INFORMATION | SWT.OK);
				msg.setText("Doppelter VariablenName");
				msg.setMessage(
					"Die VariableName existiert bereits in diesem Kontext mit einem anderen Typ, bitte whlen Sie einen anderen Namen oder den richtigen Typ.");
				msg.open();
				return;
			}
			attrValue = "";
		} else {
			int index = typeCombo.getSelectionIndex();
			if (index == NavExpConstants.TYPE_BOOLEAN) {
				attrValue =
					booleanCombo.getItem(booleanCombo.getSelectionIndex());
			} else {
				attrValue = valueText.getText();
			}
			attrVarName = "";
		}

		if (attrName == ""
			|| attrType == ""
			|| (attrValue == "" && attrVarName == "")) {
			MessageBox msg =
				new MessageBox(dialogShell, SWT.ICON_INFORMATION | SWT.OK);

			msg.setMessage(
				"Bitte geben Sie einen gltigen Attributnamen, -typ und -wert bzw. Variable an.");
			msg.open();
			return;
		}
		dialogShell.close();
	}

	public boolean isCancelled() {
		return isCancelled;
	}

	public void setValue(String value) {
		attrValue = value;
	}

	public void setVarName(String varName) {
		this.attrVarName = varName;
	}

	public String getVarName() {
		return attrVarName;
	}

	public void setName(String name) {
		attrName = name;
	}
	public void setType(String type) {
		attrType = type;
	}

	public String getValue() {
		return attrValue;
	}

	public String getName() {
		return attrName;
	}

	public String getType() {
		return attrType;
	}
	/** Auto-generated event handler method */
	protected void cancelMouseDown(MouseEvent evt) {
		isCancelled = true;
		dialogShell.close();
	}

	/** Auto-generated event handler method */
	protected void typeComboWidgetDefaultSelected(SelectionEvent evt) {

	}

	/** Auto-generated event handler method */
	protected void typeComboWidgetSelected(SelectionEvent evt) {
		typeIndex = typeCombo.getSelectionIndex();
		if (attributeValueButton.getSelection()) {
			boolean showBoolean = typeIndex == NavExpConstants.TYPE_BOOLEAN;
			booleanCombo.setVisible(showBoolean);
			valueText.setVisible(!showBoolean);
			if (typeIndex >= NavExpConstants.TYPES.length) {
				varButton.setSelection(true);
			}
		}
	}

	/** Auto-generated event handler method */
	protected void attributeValueButtonWidgetSelected(SelectionEvent evt) {
		if (typeIndex >= NavExpConstants.TYPES.length) {
			return;
		}
		varButton.setSelection(false);
		attributeValueButton.setSelection(true);
		variableText.setVisible(false);
		valueText.setVisible(typeIndex != NavExpConstants.TYPE_BOOLEAN);
		booleanCombo.setVisible(typeIndex == NavExpConstants.TYPE_BOOLEAN);
	}

	/** Auto-generated event handler method */
	protected void varButtonWidgetSelected(SelectionEvent evt) {
		attributeValueButton.setSelection(false);
		varButton.setSelection(true);
		variableText.setVisible(true);
		valueText.setVisible(false);
		booleanCombo.setVisible(false);

	}
}
