package vocleditor.edit;

import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Text;

/**
 * 
 * Class       : AssociationEndRoleCellEditorLocator<br/>
 * Package     : vocleditor.edit<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 26.06.2004<br/>
 * Description : Class for creating Editor above the label.<br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 */
final public class AssociationEndRoleCellEditorLocator implements CellEditorLocator
{

	private Label label;

	/**
	 * Constructor.
	 * @param label
	 */
	public AssociationEndRoleCellEditorLocator(Label label)
	{
		setLabel(label);
	}

	/**
	 * @see org.eclipse.gef.tools.CellEditorLocator#relocate(org.eclipse.jface.viewers.CellEditor)
	 */
	public void relocate(CellEditor celleditor)
	{
		Text text = (Text)celleditor.getControl();
		Point pref = text.computeSize(-1, -1);
		Rectangle rect = label.getTextBounds().getCopy();
		label.translateToAbsolute(rect);
		text.setBounds(rect.x - 4, rect.y - 1, pref.x + 1, pref.y + 1);
	}

	/**
	 * Returns the Label figure.
	 */
	protected Label getLabel()
	{
		return label;
	}

	/**
	 * Sets the label.
	 * @param label The label to set
	 */
	protected void setLabel(Label label)
	{
		this.label = label;
	}
}
