package vocleditor.edit;

import org.eclipse.draw2d.FigureUtilities;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Locator;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;

/**
 * 
 * Class       : AssociationEndRoleConstraint<br/>
 * Package     : vocleditor.edit<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 26.06.2004<br/>
 * Description : Creates a Locator for AssociationEndRoles.<br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 */
public class AssociationEndRoleConstraint implements Locator
{

	String text;
	boolean isEnd;
	Point offset;
	PolylineConnection connFigure;

	/**
	 * Constructor.
	 * @param text
	 * @param isEnd
	 * @param offset
	 * @param connFigure
	 */
	public AssociationEndRoleConstraint(String text, boolean isEnd, Point offset, PolylineConnection connFigure)
	{
		this.text = text;
		this.isEnd = isEnd;
		this.offset = offset;
		this.connFigure = connFigure;
	}

	/**
	 * @see org.eclipse.draw2d.Locator#relocate(org.eclipse.draw2d.IFigure)
	 */
	public void relocate(IFigure figure)
	{
		Dimension minimum = FigureUtilities.getTextExtents(text, figure.getFont());
		figure.setSize(minimum);
		Point location;
		if (isEnd)
		{
			location = connFigure.getEnd();
		}
		else
		{
			location = connFigure.getStart();
		}
		Point offsetCopy = offset.getCopy();
		offsetCopy.translate(location);
		figure.setLocation(offsetCopy);
	}
}