package vocleditor.edit.policies;


import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.DirectEditPolicy;
import org.eclipse.gef.requests.DirectEditRequest;

import vocleditor.edit.AssociationEndRoleCommand;
import VOCLModel.AssociationEndRole;

/**
 * Class       : AssociationEndRoleDirectEditPolicy<br/>
 * Package     : vocleditor.edit.policies<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 22.05.2004<br/>
 * Description : This policy is for editing the role label<br/>
 * <br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 *
 * 
 */
public class AssociationEndRoleDirectEditPolicy extends DirectEditPolicy
{
	/**
	 * Returns the command for editing the end role.
	 * @return the command
	 */
	protected Command getDirectEditCommand(DirectEditRequest edit)
	{
		String labelText = (String)edit.getCellEditor().getValue();
		AssociationEndRoleCommand command =
			new AssociationEndRoleCommand((AssociationEndRole)getHost().getModel(), labelText);
		
		return command;
	}

	/**
	 * This method must be implemented due abstract super class (no implementation)
	 */
	protected void showCurrentEditValue(DirectEditRequest request)
	{
	}
}