
package vocleditor.edit.policies;

import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.gef.ConnectionEditPart;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.editpolicies.ConnectionEndpointEditPolicy;

/**
 * Class       : AssociationRoleEndpointEditPolicy<br/>
 * Package     : vocleditor.edit.policies<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 22.05.2004<br/>
 * Description : This policy is for editing the endpoints of an association role<br/>
 * <br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 *
 * 
 */
public class AssociationRoleEndpointEditPolicy extends ConnectionEndpointEditPolicy {


	/**
	 * Add a selection handler to the association role.
	 */
	protected void addSelectionHandles(){
		super.addSelectionHandles();
		getConnectionFigure().setLineWidth(2);
	}

	/**
	 * Returns the polyline representing this association role.
	 * 
	 * @return
	 */
	protected PolylineConnection getConnectionFigure()
	{
		PolylineConnection connection = 
			(PolylineConnection)((GraphicalEditPart)getHost()).getFigure();
		return connection;
	}

	/**
	 * Removes the selection handler.
	 */
	protected void removeSelectionHandles(){
		super.removeSelectionHandles();
		getConnectionFigure().setLineWidth(1);
	}
	
	/**
	 * Returns the edit part for this association role (connection)
	 * 
	 * @return
	 */
	public ConnectionEditPart getConnectionEditPart()
		{
			return (ConnectionEditPart)getHost();
		}

}
