/*
 * Created on 21.05.2004
 */
package vocleditor.edit.policies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.ComponentEditPolicy;
import org.eclipse.gef.requests.GroupRequest;
import org.eclipse.swt.widgets.Shell;

import vocleditor.command.DeleteClassifierRoleCommand;
import vocleditor.edit.parts.ClassifierRoleSetEditPart;
import vocleditor.edit.parts.ClassifierRoleSimpleEditPart;
import VOCLModel.ClassifierNode;
import VOCLModel.ClassifierRoleSet;

/**
 * Class       : ClassifierComponentEditPolicy<br/>
 * Package     : vocleditor.edit.policies<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 22.05.2004<br/>
 * Description : This policy is for removing classifier (roles/sets)<br/>
 * <br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 *
 * 
 */
public class ClassifierComponentEditPolicy extends ComponentEditPolicy {

	/**
	 * @see org.eclipse.gef.editpolicies.ComponentEditPolicy#createDeleteCommand(org.eclipse.gef.requests.GroupRequest)
	 */
	protected Command createDeleteCommand(GroupRequest deleteRequest) {
		
		Command result = null;
		Shell shell;
		if(getHost().getModel() instanceof ClassifierRoleSet){
			shell = ((ClassifierRoleSetEditPart)getHost()).getShell();
		}else {
			shell = ((ClassifierRoleSimpleEditPart)getHost()).getShell();
		}
		
		if (getHost().getModel() instanceof ClassifierNode) {
			DeleteClassifierRoleCommand deleteCmd = new DeleteClassifierRoleCommand(shell);
			deleteCmd.setClassifierRole((ClassifierNode) getHost().getModel());
			result = deleteCmd;
		}

		return result;
	}

}
