/*
 * Created on 21.06.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vocleditor.edit.policies;

import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.XYLayoutEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.swt.widgets.Shell;

import vocleditor.command.CreateBoolExpCommand;
import vocleditor.command.CreateClassifierRoleSetCommand;
import vocleditor.command.CreateClassifierRoleSimpleCommand;
import vocleditor.command.CreateConditionCommand;
import vocleditor.command.CreateDecisionCommand;
import vocleditor.command.CreateLetExpCommand;
import vocleditor.command.CreateNavexpCommand;
import vocleditor.edit.parts.ConstraintEditPart;
import VOCLModel.BoolExp;
import VOCLModel.ClassifierRole;
import VOCLModel.ClassifierRoleSet;
import VOCLModel.Condition;
import VOCLModel.Constraint;
import VOCLModel.IfExp;
import VOCLModel.LetExp;
import VOCLModel.NavExp;

/**
 * Class       : ConstraintLayoutEditPolicy<br/>
 * Package     : vocleditor.edit.policies<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 22.05.2004<br/>
 * Description : This policy is for editing a constraint.<br/>
 * <br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 *
 * 
 */
public class ConstraintLayoutEditPolicy extends XYLayoutEditPolicy {

	/**
	 * @see org.eclipse.gef.editpolicies.ConstrainedLayoutEditPolicy#createAddCommand(org.eclipse.gef.EditPart, java.lang.Object)
	 */
	protected Command createAddCommand(EditPart child, Object constraint) {
		return null;
	}

	/**
	 * @see org.eclipse.gef.editpolicies.ConstrainedLayoutEditPolicy#createChangeConstraintCommand(org.eclipse.gef.EditPart, java.lang.Object)
	 */
	protected Command createChangeConstraintCommand(
		EditPart child,
		Object constraint) {

		return null;
	}

	/**
	 * @see org.eclipse.gef.editpolicies.LayoutEditPolicy#getCreateCommand(org.eclipse.gef.requests.CreateRequest)
	 */
	protected Command getCreateCommand(CreateRequest request) {
		Command command = null;

		Shell shell = ((ConstraintEditPart) getHost()).getShell();
		Object r = request.getNewObject();
		if (request.getNewObjectType() == Condition.class) {
			CreateConditionCommand create = new CreateConditionCommand(shell);
			create.setCondition((Condition) request.getNewObject());
			create.setParent(getHost().getModel());
			command = create;
		} else if (request.getNewObjectType() == NavExp.class) {

			CreateNavexpCommand create = new CreateNavexpCommand();
			create.setNavexp((NavExp) request.getNewObject());
			create.setParent((Constraint) getHost().getModel());
			command = create;
		} else if (request.getNewObjectType() == BoolExp.class) {
			CreateBoolExpCommand create = new CreateBoolExpCommand(shell);
			create.setBoolExp((BoolExp) request.getNewObject());
			create.setParent(getHost().getModel());
			command = create;
		} else if (request.getNewObjectType() == IfExp.class) {
			CreateDecisionCommand create = new CreateDecisionCommand();
			create.setParent(getHost().getModel());
			create.setDecision((IfExp) request.getNewObject());
			command = create;
		} else if (request.getNewObjectType() == LetExp.class) {
			CreateLetExpCommand create = new CreateLetExpCommand(shell);
			create.setLetExp((LetExp) request.getNewObject());
			create.setParent(getHost().getModel());
			command = create;
		} else if (request.getNewObjectType() == ClassifierRole.class) {
			CreateClassifierRoleSimpleCommand create =
				new CreateClassifierRoleSimpleCommand(shell);
			create.setNavexpParent(getHost().getModel());
			create.setClassifierRoleSimple(
				(ClassifierRole) request.getNewObject());
			Rectangle location = (Rectangle) getConstraintFor(request);
			create.setLocation(location);
			command = create;
		} else if (request.getNewObjectType() == ClassifierRoleSet.class) {
			CreateClassifierRoleSetCommand create =
				new CreateClassifierRoleSetCommand(shell);
			create.setNavexpParent(getHost().getModel());
			create.setClassifierRoleSet(
				(ClassifierRoleSet) request.getNewObject());
			Rectangle location = (Rectangle) getConstraintFor(request);
			create.setLocation(location);
			command = create;
		}

		return command;
	}

	/**
	 * @see org.eclipse.gef.editpolicies.LayoutEditPolicy#getDeleteDependantCommand(org.eclipse.gef.Request)
	 */
	protected Command getDeleteDependantCommand(Request request) {
		return null;
	}

}
