/*
 * Created on 28.06.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vocleditor.edit.policies;

import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.XYLayoutEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.swt.widgets.Shell;

import vocleditor.command.CreateBoolExpCommand;
import vocleditor.command.CreateClassifierRoleSetCommand;
import vocleditor.command.CreateClassifierRoleSimpleCommand;
import vocleditor.command.CreateConditionCommand;
import vocleditor.command.CreateDecisionCommand;
import vocleditor.command.CreateLetExpCommand;
import vocleditor.command.NotExpCommand;
import vocleditor.edit.parts.VOCLExpEditPart;
import vocleditor.figures.VOCLExpFigure;
import vocleditor.model.NotExp;
import VOCLModel.BoolExp;
import VOCLModel.ClassifierRole;
import VOCLModel.ClassifierRoleSet;
import VOCLModel.Condition;
import VOCLModel.IfExp;
import VOCLModel.LetExp;
import VOCLModel.VOCLExpression;

/**
 * Class       : VOCLExpLayoutEditPolicy<br/>
 * Package     : vocleditor.edit.policies<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 22.05.2004<br/>
 * Description : This policy is for creating VOCL expressions<br/>
 * <br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 *
 * 
 */
public class VOCLExpLayoutEditPolicy extends XYLayoutEditPolicy {

	/**
	 * @see org.eclipse.gef.editpolicies.LayoutEditPolicy#createChildEditPolicy(org.eclipse.gef.EditPart)
	 */
	protected EditPolicy createChildEditPolicy(EditPart child) {
		return null;
	}

	/**
	 * @see org.eclipse.gef.editpolicies.LayoutEditPolicy#getCreateCommand(org.eclipse.gef.requests.CreateRequest)
	 */
	protected Command getCreateCommand(CreateRequest request) {
		Command command = null;
		int p = ((VOCLExpFigure) getHostFigure()).returnBereich();
		Point classiferLocation =
			((VOCLExpFigure) getHostFigure()).getClassifierLocation();
		Shell shell = ((VOCLExpEditPart) getHost()).getShell();
		if (request.getNewObjectType() == ClassifierRole.class) {

			CreateClassifierRoleSimpleCommand create =
				new CreateClassifierRoleSimpleCommand(shell);
			create.setPosition(p);
			create.setClassifierRoleSimple(
				(ClassifierRole) request.getNewObject());
			create.setNavexpParent((VOCLExpression) getHost().getModel());
			Rectangle rectangle = (Rectangle) getConstraintFor(request);
			create.setLocation(classiferLocation);
			command = create;
		} else if (request.getNewObjectType() == ClassifierRoleSet.class) {

			CreateClassifierRoleSetCommand create =
				new CreateClassifierRoleSetCommand(shell);
			create.setPosition(p);
			create.setClassifierRoleSet(
				(ClassifierRoleSet) request.getNewObject());
			create.setNavexpParent((VOCLExpression) getHost().getModel());
			Rectangle rectangle = (Rectangle) getConstraintFor(request);
			create.setLocation(rectangle);
			command = create;
		} else if (request.getNewObjectType() == BoolExp.class) {
			CreateBoolExpCommand create = new CreateBoolExpCommand(shell);
			create.setParent((VOCLExpression) getHost().getModel());
			create.setBoolExp((BoolExp) request.getNewObject());
			create.setPosition(p);
			command = create;
		} else if (request.getNewObjectType() == LetExp.class) {
			CreateLetExpCommand create = new CreateLetExpCommand(shell);
			create.setParent(getHost().getModel());
			create.setLetExp((LetExp) request.getNewObject());
			create.setPosition(p);
			command = create;
		} else if (request.getNewObjectType() == IfExp.class) {
			CreateDecisionCommand create = new CreateDecisionCommand();
			create.setParent(getHost().getModel());
			create.setDecision((IfExp) request.getNewObject());
			create.setShell(shell);
			create.setPosition(p);
			command = create;
		} else if (request.getNewObjectType() == Condition.class) {
			CreateConditionCommand create = new CreateConditionCommand(shell);
			create.setPosition(p);
			create.setCondition((Condition) request.getNewObject());
			create.setNavexpParent(getHost().getModel());
			command = create;
		} else if (request.getNewObjectType() == NotExp.class) {
			NotExpCommand create = new NotExpCommand();
			create.setPosition(p);
			//create.setCondition((Condition) request.getNewObject());
			create.setParent(getHost().getModel());
			command = create;
		}
		return command;
	}

	/**
	 * @see org.eclipse.gef.editpolicies.LayoutEditPolicy#getDeleteDependantCommand(org.eclipse.gef.Request)
	 */
	protected Command getDeleteDependantCommand(Request request) {
		return null;
	}

	/**
	 * @see org.eclipse.gef.editpolicies.LayoutEditPolicy#getMoveChildrenCommand(org.eclipse.gef.Request)
	 */
	protected Command getMoveChildrenCommand(Request request) {
		return null;
	}

	/**
	 * @see org.eclipse.gef.editpolicies.ConstrainedLayoutEditPolicy#createAddCommand(org.eclipse.gef.EditPart, java.lang.Object)
	 */
	protected Command createAddCommand(EditPart child, Object constraint) {
		return null;
	}

	/**
	 * @see org.eclipse.gef.editpolicies.ConstrainedLayoutEditPolicy#createChangeConstraintCommand(org.eclipse.gef.EditPart, java.lang.Object)
	 */
	protected Command createChangeConstraintCommand(
		EditPart child,
		Object constraint) {
		return null;
	}

}
