/* 
 * $Id: InvalidModelException.java,v 1.2 2004/11/09 09:49:37 haensgen Exp $
 */
 
package VoclToOclConverter;

import java.util.List;
import java.util.Iterator;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.MultiStatus;

/**
 * Indicates that an EMF model instance does not represent a Visual OCL 
 * expression, i.e. is an invalid model instance.
 */
public class InvalidModelException extends CoreException {
	
	/**
	 * Creates a new InvalidModelException.
	 * 
	 * @param invalidElementStates
	 *     A list of ElementStatus instances of invalid elements.
	 */
	public InvalidModelException(List invalidElementStates) {
		super(new MultiStatus(VoclToOclConverterPlugin.PLUGIN_ID, 0, "", null));
		MultiStatus status = (MultiStatus)getStatus();	
		for (Iterator it = invalidElementStates.iterator(); it.hasNext(); )
			status.add((IStatus)it.next());
	}
}
