/* 
 * $Id: ModelConverterException.java,v 1.2 2004/11/09 09:49:37 haensgen Exp $
 */
 
package VoclToOclConverter;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;

/**
 * Indicates an error while converting a Visual OCL expression into an OCL
 * meta model.
 */
public class ModelConverterException extends CoreException {

	/**
	 * Creates a new ModelConverterException with the given error code and 
	 * message.
	 * 
	 * @param code
	 *     The error code. See <tt>IModelConverterErrorCodes</tt> for such 
	 *     codes. 
	 * @param message
	 *     The message which describes the error.
	 * 
	 * @see IModelConverterErrorCodes
	 */
	public ModelConverterException(int code, String message) {
		super(new Status(
			IStatus.ERROR,
			VoclToOclConverterPlugin.PLUGIN_ID,
			code,
			message,
			null));		
	}
	
	/**
	 * Returns a string representation of the exception.
	 */
	public String toString() {
		return getStatus().getMessage();
	}
}
